#!/bin/sh

if test "$DEBUG" -o "$INTERNAL_LOG_LEVEL" = debug; then
    set -x
    export NODE_ENV=${NODE_ENV:-debug}
else
    export NODE_ENV=${NODE_ENV:-production}
fi

MONGODB_DATABASE=${MONGODB_DATABASE:-wekan}
MONGODB_HOST=${MONGODB_HOST:-mongodb-wekan}
MONGODB_PASSWORD=${MONGODB_PASSWORD:-secret}
MONGODB_PORT=${MONGODB_PORT:-27017}
MONGODB_USER=${MONGODB_USER:-wekan}

if test "`id -u`" -ne 0; then
    sed "s|^wekan:.*|wekan:x:`id -g`:|" /etc/group >/var/run/wekan-group
    sed "s|^wekan:.*|wekan:x:`id -u`:`id -g`:wekan:/build:/usr/sbin/nologin|" \
	/etc/passwd >/var/run/wekan-passwd
    export LD_PRELOAD=/usr/lib/libnss_wrapper.so
    export NSS_WRAPPER_PASSWD=/var/run/wekan-passwd
    export NSS_WRAPPER_GROUP=/var/run/wekan-group
fi
. /usr/local/bin/reset-tls.sh

export ACCOUNTS_LOCKOUT_KNOWN_USERS_FAILURES_BEFORE=${ACCOUNTS_LOCKOUT_KNOWN_USERS_FAILURES_BEFORE:-3} \
    ACCOUNTS_LOCKOUT_KNOWN_USERS_FAILURE_WINDOW=${ACCOUNTS_LOCKOUT_KNOWN_USERS_FAILURE_WINDOW:-15} \
    ACCOUNTS_LOCKOUT_KNOWN_USERS_PERIOD=${ACCOUNTS_LOCKOUT_KNOWN_USERS_PERIOD:-60} \
    ACCOUNTS_LOCKOUT_UNKNOWN_USERS_FAILURES_BERORE=${ACCOUNTS_LOCKOUT_UNKNOWN_USERS_FAILURES_BERORE:-3} \
    ACCOUNTS_LOCKOUT_UNKNOWN_USERS_FAILURE_WINDOW=${ACCOUNTS_LOCKOUT_UNKNOWN_USERS_FAILURE_WINDOW:-15} \
    ACCOUNTS_LOCKOUT_UNKNOWN_USERS_LOCKOUT_PERIOD=${ACCOUNTS_LOCKOUT_UNKNOWN_USERS_LOCKOUT_PERIOD:-60} \
    MONGO_URL="mongodb://${MONGODB_USER}:${MONGODB_PASSWORD}@${MONGODB_HOST}:${MONGODB_PORT}/${MONGODB_DATABASE}" \
    PORT=${PORT:-8080} WITH_API=${WITH_API:-false} WRITABLE_PATH=${WRITABLE_PATH:-/data}

for p in "/$CUSTOM_LOGO.png" "/$CUSTOM_LOGO"
do
    if test -s "$p"; then
	cp -p "$p" /build/programs/web.browser/app/wekan-logo-header.png
    fi
done
if test "$LDAP_BASEDN"; then
    LDAP_BIND_PREFIX="${LDAP_BIND_PREFIX:-cn=wekan,ou=services}"
    if test -z "$LDAP_BACKGROUND_SYNC_INTERVAL"; then
	LDAP_BACKGROUND_SYNC_INTERVAL="every 10 minutes"
    fi
    export DEFAULT_AUTHENTICATION_METHOD=${DEFAULT_AUTHENTICATION_METHOD:-ldap} \
	LDAP_AUTHENTIFICATION=${LDAP_AUTHENTIFICATION:-true} \
	LDAP_AUTHENTIFICATION_PASSWORD="${LDAP_AUTHENTIFICATION_PASSWORD:-secret}" \
	LDAP_BACKGROUND_SYNC=${LDAP_BACKGROUND_SYNC:-true} \
	LDAP_BACKGROUND_SYNC_IMPORT_NEW_USERS=${LDAP_BACKGROUND_SYNC_IMPORT_NEW_USERS:-true} \
	LDAP_BACKGROUND_SYNC_INTERVAL \
	LDAP_BACKGROUND_SYNC_KEEP_EXISTANT_USERS_UPDATED=${LDAP_BACKGROUND_SYNC_KEEP_EXISTANT_USERS_UPDATED:-true} \
	LDAP_CONNECT_TIMEOUT=${LDAP_CONNECT_TIMEOUT:-2000} \
	LDAP_DEFAULT_DOMAIN=${LDAP_DEFAULT_DOMAIN:-demo.local} \
	LDAP_EMAIL_MATCH_ENABLE=${LDAP_EMAIL_MATCH_ENABLE:-false} \
	LDAP_EMAIL_MATCH_REQUIRE=${LDAP_EMAIL_MATCH_REQUIRE:-false} \
	LDAP_IDLE_TIMEOUT=${LDAP_IDLE_TIMEOUT:-10000} \
	LDAP_EMAIL_FIELD=${LDAP_EMAIL_FIELD:-mail} \
	LDAP_ENABLE=${LDAP_ENABLE:-true} \
	LDAP_GROUP_FILTER_GROUP_ID_ATTRIBUTE=${LDAP_GROUP_FILTER_GROUP_ID_ATTRIBUTE:-cn} \
	LDAP_GROUP_FILTER_GROUP_MEMBER_ATTRIBUTE=${LDAP_GROUP_FILTER_GROUP_MEMBER_ATTRIBUTE:-member} \
	LDAP_GROUP_FILTER_GROUP_MEMBER_FORMAT=${LDAP_GROUP_FILTER_GROUP_MEMBER_FORMAT:-dn} \
	LDAP_LOG_ENABLED=${LDAP_LOG_ENABLED:-false} \
	LDAP_LOGIN_FALLBACK=${LDAP_LOGIN_FALLBACK:-false} \
	LDAP_PORT=${LDAP_PORT:-1389} \
	LDAP_RECONNECT=${LDAP_RECONNECT:-true} \
	LDAP_REJECT_UNAUTHORIZED=${LDAP_REJECT_UNAUTHORIZED:-true} \
	LDAP_SYNC_USER_DATA=${LDAP_SYNC_USER_DATA:-true} \
	LDAP_TIMEOUT=${LDAP_TIMEOUT:-10000} \
	LDAP_UNIQUE_IDENTIFIER_FIELD=${LDAP_UNIQUE_IDENTIFIER_FIELD:-entryUUID} \
	LDAP_USER_SEARCH_FIELD=${LDAP_USER_SEARCH_FIELD:-uid} \
	LDAP_USER_SEARCH_SCOPE=${LDAP_USER_SEARCH_SCOPE:-sub} \
	LDAP_USERNAME_FIELD=${LDAP_USERNAME_FIELD:-uid} \
	LDAP_UTF8_NAMES_SLUGIFY=${LDAP_UTF8_NAMES_SLUGIFY:-true}
    if test "$LDAP_PROTO" = ldaps; then
	export LDAP_ENCRYPTION=ssl
    fi
    export LDAP_AUTHENTIFICATION_USERDN="$LDAP_BIND_PREFIX,$LDAP_BASEDN" \
	LDAP_GROUP_FILTER_OBJECTCLASS=${LDAP_GROUP_FILTER_OBJECTCLASS:-groupOfNames}
    if test "$LDAP_IS_IPA"; then
	export LDAP_BASEDN="cn=users,cn=accounts,$LDAP_BASEDN" \
	    LDAP_FULLNAME_FIELD=${LDAP_FULLNAME_FIELD:-displayName} \
	    LDAP_GROUP_FILTER_ENABLE=${LDAP_GROUP_FILTER_ENABLE:-false}
    else
	export LDAP_FULLNAME_FIELD=${LDAP_FULLNAME_FIELD:-sn} \
	    LDAP_GROUP_FILTER_ENABLE=${LDAP_GROUP_FILTER_ENABLE:-true}
    fi
    if test -z "$LDAP_GROUP_FILTER_GROUP_NAME"; then
	LDAP_GROUP_FILTER_GROUP_NAME="*"
    fi
    if test -z "$LDAP_USER_SEARCH_FILTER"; then
	export LDAP_USER_SEARCH_FILTER="(&(objectClass=inetOrgPerson)(!(pwdAccountLockedTime=*)))"
    fi
    if test -z "$LDAP_SYNC_USER_DATA_FIELDMAP"; then
	export LDAP_SYNC_USER_DATA_FIELDMAP="{\"$LDAP_FULLNAME_FIELD\":\"name\",\"mail\":\"email\"}"
    fi
    if test "$LEMON_PROTO" -a "$LDAP_DEFAULT_DOMAIN"; then
	export OAUTH2_AUTH_ENDPOINT=${OAUTH2_AUTH_ENDPOINT:-/oauth2/authorize} \
	    OAUTH2_CLIENT_ID=${OAUTH2_CLIENT_ID:-wekan} \
	    OAUTH2_ENABLED=true \
	    OAUTH2_ID_MAP=${OAUTH2_ID_MAP:-sub} \
	    OAUTH2_SECRET="${OAUTH2_SECRET:-wekan}" \
	    OAUTH2_SERVER_URL=$LEMON_PROTO://auth.$LDAP_DEFAULT_DOMAIN \
	    OAUTH2_TOKEN_ENDPOINT=${OAUTH2_TOKEN_ENDPOINT:-/oauth2/token} \
	    OAUTH2_USERINFO_ENDPOINT=${OAUTH2_USERINFO_ENDPOINT:-/oauth2/userinfo}
    else
	export OAUTH2_ENABLED=false
    fi
else
    export LDAP_ENABLE=false
fi

unset MONGODB_USER MONGODB_PASSWORD MONGODB_HOST MONGODB_PORT MONGODB_DATABASE

exec "$@"
